function y = gen2cyclerep(permarr,repdim,ST)

%Michael Stephanou, 2007

y = zeros(repdim);

TempST = [];

for i = 1:length(ST)
    TempST{i,1} = ST{i};
    TempST{i,2} = i;
end

permcyc = arrtocycle(permarr);

cycle1 = permcyc(1);
cycle2 = permcyc(2);

while size(TempST,1) > 0
    
    
    
    samecolrowflg = samerowcol(TempST{1,1},cycle1,cycle2);
    
    if samecolrowflg == 1
        i = TempST{1,2};
        y(i,i) = 1;
        TempST(1,:) = [];
    end
    
    if samecolrowflg == 2
        i = TempST{1,2};
        y(i,i) = -1;
        TempST(1,:) = [];
    end
    
    if size(TempST,1) >= 1
           IsSub = submatrixin(TempST{1,1},TempST,cycle1,cycle2);
    
        if IsSub(1) ~= 0
            k = IsSub(1);
            i = TempST{1,2};
            disty = distyoung(TempST{1,1},cycle1,cycle2);
            y(i,i) = -1/disty;
            y(i,k) = sqrt(1 - (1/disty)^2); %sqrt
            y(k,i) = sqrt(1 - (1/disty)^2);
            y(k,k) = 1/disty;
            TempST(IsSub(2),:) = [];
            TempST(1,:) = [];
        end 
    end
end


