function y = CreateRetrieveGenc(partition);

flag = 1;
fid = fopen('2cycs.mat');
if  fid ~= -1
    if exist('generatingctmplststor','var') == 0
        load 2cycs;
        generatingctmplst = generatingctmplststor;
    end
    %fclose(fid);
    %load 2cycs;
else
   generatingctmplst = []; 
end

sz = length(generatingctmplst);

for i = 1:sz
   if length(generatingctmplst{i}{length(generatingctmplst{i})}) == length(partition)
       if generatingctmplst{i}{length(generatingctmplst{i})} == partition
           indx = i;
           flag = 0;
           break;
       end
   end
end;

if flag == 1
    
    n = sum(partition);
    inittab = initializetableau(partition);
    dim = sndim(partition);
    y = eye(dim);

    global STbuild;

    STbuild = [];

    buildtableaux(inittab,inittab);

    temp = [];
    for k = 1:length(STbuild)
        temp{k} = STbuild{length(STbuild)-k+1};
    end
    STbuild  = temp;

    for k = 1:(n-1)  
        curarr = cycletoarr([k,k+1],n);
        generatingctmplst{sz+1}{k} = gen2cyclerep(curarr,dim,STbuild);
    end

    generatingctmplst{sz+1}{k+1} = partition;
    
    indx = sz+1;

    generatingctmplststor = generatingctmplst; 
    save 2cycs generatingctmplststor;
    clear generatingctmplststor;

 
end


% celldisp(generatingctmplst)


y = generatingctmplst{indx};
y((length(generatingctmplst{indx}))) = [];

fclose('all');
