function clist = arrtocyclenew(inputarr)

% Michael Stephanou 2007
% Norman Ives 2008

n = length(inputarr);
done = [];
ndone = 0;
clist = {}; % list of cycles which compose to be equivalent to inputarr
nc = 0; % number of cycles
for i = 1:n
	if sum(done==i) > 0
		continue;
	end
	ndone=ndone+1;
	done(ndone)=i;
	k = 1; % index into current array
	c(k) = i;% current cycle
	e = i; % tracks permuted item
	while inputarr(e) ~= c(1)
		k = k+1;
		c(k) = inputarr(e);
		e = c(k);
		ndone=ndone+1;
		done(ndone)=e;
    end
	
    if length(c)>1
        nc = nc + 1;
        clist{nc} = c;
    end
	clear c;
end
